// //////////////////////////////////////////////////////////////////////////
//
//     symmops.h
//     (c) 2007 Frank DiMaio
//
// //////////////////////////////////////////////////////////////////////////
//
//     This file is part of ACMI.
//
//     ACMI is free software; you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation; either version 3 of the License, or
//     (at your option) any later version.
//
//     ACMI is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// //////////////////////////////////////////////////////////////////////////

#ifndef _SYMMOPS_H_
#define _SYMMOPS_H_ 1

#include <vector>
#include <cstring>
#include <cstdlib>
#include <string>
#include <iostream>
using namespace std;

class R3_transform {
public:
	R3_transform(double r11, double r12, double r13,
	             double r21, double r22, double r23,
	             double r31, double r32, double r33,
	             double t1, double t2, double t3) {
		this->rot[0][0] = r11; this->rot[0][1] = r12; this->rot[0][2] = r13;
		this->rot[1][0] = r21; this->rot[1][1] = r22; this->rot[1][2] = r23;
		this->rot[2][0] = r31; this->rot[2][1] = r32; this->rot[2][2] = r33;

		this->trans[0] = t1; this->trans[1] = t2; this->trans[2] = t3;
	}

	double rot[3][3];
	double trans[3];
};

int getSymmOps(int spacegp, string &laueGpId, vector<R3_transform> &symmOps);
int spacegpID(string id);

#endif
